/************************************************************************************/
/*  Program name CAPAPEXT_PAY_HISTORY.sql                                           */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_PAY_HISTORY';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_PAY_HISTORY.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_B (p_NGO VARCHAR2) IS
	SELECT
		F.*,
		B.Name	OU_Name
	FROM
		AP_PAYMENT_HISTORY_ALL			F,
		HR_ALL_ORGANIZATION_UNITS		B,
		HR_ORGANIZATION_INFORMATION		I
	WHERE	SUBSTR(B.Name,4,4)			=	p_NGO
	AND		B.Organization_ID			=	F.Org_ID
	AND		B.Organization_ID			=	I.Organization_ID
	AND		I.Org_Information_Context	=	'Operating Unit Information';

BEGIN
	lv_NGO		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_B(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Payment_History_ID||CHR(9)||
				C1.Check_ID||CHR(9)||
				C1.Accounting_Date||CHR(9)||
				C1.Transaction_Type||CHR(9)||
				C1.Posted_Flag||CHR(9)||
				C1.Matched_Flag||CHR(9)||
				C1.Accounting_Event_ID||CHR(9)||
					C1.Org_ID||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Program_Update_Date||CHR(9)||
				C1.Program_Application_ID||CHR(9)||
				C1.Program_ID||CHR(9)||
				C1.Request_ID||CHR(9)||
				C1.Rev_Pmt_Hist_ID||CHR(9)||
				C1.Trx_Bank_Amount||CHR(9)||
				C1.Errors_Bank_Amount||CHR(9)||
				C1.Charges_Bank_Amount||CHR(9)||
				C1.Trx_Pmt_Amount||CHR(9)||
				C1.Errors_Pmt_Amount||CHR(9)||
				C1.Charges_Pmt_Amount||CHR(9)||
				C1.Trx_Base_Amount||CHR(9)||
				C1.Errors_Base_Amount||CHR(9)||
				C1.Charges_Base_Amount||CHR(9)||
				C1.Bank_Currency_Code||CHR(9)||
				C1.Bank_To_Base_Xrate_Type||CHR(9)||
				C1.Bank_To_Base_Xrate_Date||CHR(9)||
				C1.Bank_To_Base_Xrate||CHR(9)||
				C1.Pmt_Currency_Code||CHR(9)||
				C1.Pmt_To_Base_Xrate_Type||CHR(9)||
				C1.Pmt_To_Base_Xrate_Date||CHR(9)||
				C1.Pmt_To_Base_Xrate||CHR(9)||
				C1.Mrc_Pmt_To_Base_Xrate_Type||CHR(9)||
				C1.Mrc_Pmt_To_Base_Xrate_Date||CHR(9)||
				C1.Mrc_Pmt_To_Base_Xrate||CHR(9)||
				C1.Mrc_Bank_To_Base_Xrate_Type||CHR(9)||
				C1.Mrc_Bank_To_Base_Xrate_Date||CHR(9)||
				C1.Mrc_Bank_To_Base_Xrate||CHR(9)||
				C1.Mrc_Trx_Base_Amount||CHR(9)||
				C1.Mrc_Errors_Base_Amount||CHR(9)||
				C1.Mrc_Charges_Base_Amount||CHR(9)||
				C1.OU_Name||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/